<template>
    <div id="home" v-loading.fullscreen="isshow" :element-loading-text="istype"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)">
    <div v-wechat-title="$route.meta.title=name"></div>
        <div class="box" v-if="detailshow">
            <div class="top">
                        <span>员工</span>
                        <span>费用类别</span>
                        <span>发生日期</span>
                        <span>费用金额</span>
            </div>
            <div class="blockgray"></div>
            <div class="boxdata" v-for="(item,index) in datalist" :key="index">
                <div class="toptitle">

                  <!-- <img class="image1" src="../../assets/four.png" alt=""> -->
                    <div class="left">
                        <span>{{item.year}}年{{item.Month}}月</span>
                    </div>
                    <div class="right">
                        <span>CNY&nbsp;{{item.total}}</span>
                    </div>
                </div>
                <ul class="list" v-for="(itemt,index) in item.conlist" :key="index">
                    <li>{{itemt.StaffName}}</li>
                    <li>{{itemt.reimbursementStyle}}</li>
                    
                    <li>{{itemt.invoiceDate}}</li>    
                    <li>{{itemt.CurrencyIsoCode}}&nbsp;{{itemt.reimbursementAmount}}</li>
                </ul>
                   
               
            </div>
            
            
            <div class="blockgrayw"></div>
           
        </div>
        <div id="dashboard" :style="dashshow==false?{'display':'none'}:''">
            <div id="circleChart"></div>
            <div id="myChart"></div>
            <h1 v-if="peplelist.length>0" style="color:black; font-weight:500; font-size:0.28rem;text-align:center;">项目费用的组成</h1><br />
            
            <table style="border:1" v-if="peplelist.length>0">
                <tr>
                    <th>姓名</th>
                    <th>金额</th>
                </tr>
                <tr v-for="(item,index) in peplelist" :key="index" @click="topepledetail(item)">
                    <td>{{item.name}}</td>
                    <td>{{item.money}}</td>
                </tr>
            </table><br />
            <p v-if="tipshow" style="text-align:center; color:red;">注：共有费用指项目组成员所共有的费用，如团建费等。</p>
        </div>
        <div class="blockgrayw"></div>
        <div class="footer">
            <button :class="isclick? 'normalbtn':'clickbtn'" @click="lookdashboard()"><img style="width:0.4rem; height:0.4rem; margin-top:0.3rem; margin-left:0.7rem" class="image1" src="../../assets/dashboard.png">&nbsp;<span>DashBoard</span></button>
            <button :class="isclick? 'clickbtn':'normalbtn'" @click="lookdetail()"><img style="width:0.6rem; height:0.6rem; margin-top:0.18rem; margin-left:0.7rem;" class="image1" src="../../assets/mingxi.png">&nbsp;<span>查看明细</span></button>
        </div>
        <el-dialog
            title="提示"
            :visible.sync="issave"
            width="90%"
            height="20vh"
           >
            <span style="margin:0 auto; width:20%;">{{word}}</span>
            <span slot="footer" class="dialog-footer">
                <el-button style="background:#5C77A0; color:white;" @click="sureback()">确 定</el-button>
            </span>
        </el-dialog>
    </div>
</template>
<script>
import format from '../../utils/format.js';
export default {
    data(){
        return{
            isshow:false,
            istype:'',
            issave:false,
            word:'',
            datalist:[],
            dashshow:true,
            detailshow:'',
            monthlist:[],
            moneylist:[],
            peplelist:[],
            Monthcostlist:[],
            stagetype:[],
            stagecost:[],
            StageCostlist:[],
            standsize:document.body.clientWidth,
            yearmonth:'',
            isclick:true,
            name:'',
            tipshow:false
        }
    },
     computed:{
        
        options(){
            let that=this;
            var labelOption={

                normal:{
                    show:true,
                    //position:'insideBottom',
                    rotate:90,
                    formatter:function(strNum){
                       let a=format(Number(strNum.data));
                       return a;
                    }
                }
                
            }
            let option={
                  title:{
                     text:'近'+this.monthlist.length+'个月项目费用分布',
                     x:'center',
                     textStyle:{
                         fontSize:'14',
                         lineHeight:'60'
                     }
                 },
                 tooltip:{
                    trigger:'axis',
                    formatter:function(szlb){
                        console.log(szlb);
                        console.log(that);
                        console.log(szlb[0].axisValue);
                        // let index=szlb[0].axisValue.indexOf('/');
                        // that.testdata=szlb[0].axisValue.substring(index+1);
                        //console.log( that.testdata);
                        that.Monthcostlist.filter((val,index)=>{
                            if(val.year+'/'+val.Month==szlb[0].axisValue){
                                that.peplelist=[];
                                that.yearmonth=val.year+'/'+val.Month;
                                val.Monthlist.filter((val,index)=>{
                                    that.peplelist.push({StaffID:val.StaffID,name:val.StaffName,money:format(Number(val.Money))})
                                })
                            }
                        })
                    }
                },
                 xAxis : [
                    {
                        type : 'category',
                        data : '',
                        axisLabel:{interval: 0}
                    }
                    ],
                yAxis : [
                    {
                        type : 'value',
                        axisLabel: {
                        formatter:'{value}'
                        },
                       
                    }
                ],
                series : [
                    {
                        // name:'蒸发量',
                        type:'bar',
                        data:'',
                       itemStyle:{
                            normal:{color:'#63A0A7'}
                        },
                        label: labelOption,

                        // itemStyle:{

                        // },
                        // markPoint : {
                        //     symbolSize:70,
                        //     data : [
                        //         {value:2.0,xAxis:0,yAxis:2.0},
                        //         {value:7000000.0,xAxis:3,yAxis:23.2},
                        //     ]
                        // },
                        // markPoint : {
                        //     data : [
                        //         {coord: [1, 5],value:2.0},
                        //         {type : 'average'}
                        //     ]
                        // },
                        // markLine : {
                        //     data : [
                        //         {type : 'average', name: '平均值'}
                        //     ]
                        // }
                    },
                
                ]
            }
            return option;
        },
        circleoptions(){
            let option={
               title:{
                     text:'项目各费用类型占比',
                     x:'center',
                     textStyle:{
                         fontSize:'14',
                         lineHeight:'40'
                     },

                 },
               // legend:{},
                 legend: {
                    orient: 'horizontal',
                     x: 'center',
                    y:'bottom',
                    data:'',
                    //left:'0',
                    top:'85%',
                },
                // dataset:{
                //     source:''
                //             // ['直接访问',335],
                //             // ['邮件营销',310],
                //             // ['联盟广告',234],
                //             // ['视频广告',135],
                //             // ['搜索引擎',1548]
                    
                // },
                series:[
               
                    {
                        name:'访问来源',
                        type:'pie',
                        radius: ['0%', '58%'],
                         center: ['50%', '50%'],
                        avoidLabelOverlap: false,
                        minAngle:15,
                       label: {
                                normal: {
                                    show: true,
                                    formatter: function(data){return format(data.value)},
                                    textStyle: {
                                        fontSize: this.standSize / 150,
                                        // color: "#fff"
                                    },
                                },
                            },
                        // labelLine: {
                        //         normal: {
                        //             lineStyle: {
                        //                 color: 'rgba(255, 255, 255, 0.3)'
                        //             },
                        //             smooth: 0.2,
                        //             length: this.standSize / 50,
                        //             length2: this.standSize / 100,
                        //         }
                        //     },
                       
                        data:'',
                        
                      //  formatter:function(data){return format(data)}
                    }
                ]
            }
            return option;
        }
    },
    methods:{
        lookdashboard(){
            this.dashshow=true;
             this.detailshow=false;
             this.isclick=true;
        },
        lookdetail(){
             this.detailshow=true;
             this.dashshow=false;
              this.isclick=false;
        },
        sureback(){
            this.issave=false;
        },
        topepledetail(item){
           // this.$router.push({path:'./pepledetail',query:{pid:this.$route.query.id,StaffID:item.StaffID,CostTime:this.yearmonth}})
        },
         drawline(){
            let myChart = this.$echarts.init(document.getElementById('myChart'));
            // 绘制图表
            //console.log("option"+this.options);
            let circleChart= this.$echarts.init(document.getElementById('circleChart'));
            console.log(this.datalist[0])
                if(this.Monthcostlist.length>0){
                     myChart.setOption(this.options)
                }
                if(this.StageCostlist.length>0){
                    circleChart.setOption(this.circleoptions)
                }
            
            
             

        }
    },
    created(){
         let that=this;
         that.name=that.$route.query.name;
        that.isshow=true;
        that.istype='加载中';
        that.yearmonth="";
         client.apexrest('/rest/ProjectSummary?Pid='+that.$route.query.id,function(data){
                  console.log(data);
                  that.isshow=false;
                  if(data.Status=="Success"){
                       
                      if(data.dataList.length>0){
                          that.datalist=data.dataList;
                        
                          that.datalist.filter((val,index)=>{
                              val.total=format(Number(val.total));
                              val.conlist.filter((val,index)=>{
                                  val.reimbursementAmount=format(Number(val.reimbursementAmount))
                              })
                          })
                      }else{
                           that.datalist=[];
                            that.issave=true;
                            that.word='您的项目暂未产生项目费用哟～～';
                      }
                      if(data.Monthcostlist.length>0){
                          that.Monthcostlist=data.Monthcostlist;
                          data.Monthcostlist.filter((val,index)=>{
                              that.monthlist.push(val.year+'/'+val.Month);
                            //   val.TatolMonthCost=format(Number(val.TatolMonthCost));
                            //   console.log(val.TatolMonthCost);
                              that.moneylist.push(val.TatolMonthCost);
                          
                          })
                       
                          console.log(that.options.xAxis[0].data)
                          that.options.xAxis[0].data=that.monthlist;
                          that.options.series[0].data=that.moneylist;
                      }else{
                          that.monthlist=[];
                           that.moneylist=[];
                      }
                      if(data.totalist.length>0){
                          that.tipshow=true;
                          data.totalist.filter((val,index)=>{
                                that.peplelist.push({StaffID:val.StaffID,name:val.StaffName,money:format(Number(val.Money))})
                          })

                      }else{
                          that.peplelist=[];
                      }
                      if(data.StageCostlist.length>0){
                          that.StageCostlist=data.StageCostlist
                          data.StageCostlist.filter((val,index)=>{
                              that.stagetype.push(val.NProjectStage);
                              that.stagecost.push({value:val.Cost,name:val.NProjectStage})
                              that.circleoptions.legend.data=that.stagetype;
                              that.circleoptions.series[0].data=that.stagecost;
                          })
                      }
                      that.drawline();

                  }else{
                      that.issave=true;
                      that.word=data.Message;
                      console.log(data.Message);
                  }
                },function(error){
                  that.isshow=false;
                  that.issave=true;
                  that.word=error;
                  console.log(error);

                },'GET',null,true)
    }

}
</script>


<style lang="scss" type="text/scss" scoped>
    #home{
        width:100%;
        margin: 0 auto;
    }
    #home #dashboard{
        width: 100%;
    }
     #home #dashboard #myChart{
         width:100%;
         height: 300px;
     }
     #home #dashboard #circleChart{
          width:100%;
         height: 300px;
     }
     #home #dashboard table{
         width: 90%;
        margin:0 auto;
        border-radius: 0.2rem;
     }
     #home #dashboard table tr{
         width: 100%;
         height: 1rem;
         background: white;

     }
      #home #dashboard table tr th{
             height: 0.6rem;
             line-height: 1rem;
             border:0.02rem solid lightgray;
             color:white;
             background: #63A0A7;
             
      }
       #home #dashboard table tr th:first-child{
           width:23%;
       }

     #home #dashboard table tr td{
         //width: 50%;
         height: 0.6rem;
         line-height: 1rem;
         text-align: center;
          border:0.02rem solid lightgray;
          color: gray;
     }
     #home #dashboard table tr td:first-child{
         width: 23%;
     }
    //   #home #dashboard .box{
    //       width: 100%;
    //       height: 1rem;
    //       display: flex;
    //       align-items: center;
    //   }
    //    #home #dashboard .box li{
    //        width: 50%;
    //        height: 1rem;
           
    //    }
    #home .box{
        width:100%;
        margin: 0 auto;
        /* height: 4rem; */
        /* background: white; */
        /* height: 1rem; */
        /* border-radius: 0.2rem; */
        /* box-shadow: 0.2rem 0.2rem #eeeeee; */
        /* margin-top: 0.2rem; */
    }
    #home .box .top{
        width:100%;
        margin: 0 auto;
        height: 1rem;
        display: flex;
        position: fixed;
        left: 0;
        top: 0;
        background: white;
      /* box-shadow: 0.1rem 0.1rem #eeeeee; */
        border-bottom: 0.02rem solid lightgray;
       
        /* font-size: 0.28rem; */
    }
    #home .box .top span{
        width: 25%;
        height: 1rem;
        text-align: center;
        line-height: 1rem;
        color: #5477AB;
        font-weight: 600;
    }
    #home .box .boxdata{
        width:100%;
        /* background: white; */
        // margin-top: 1rem;
    }
     #home .box .blockgray{
         width: 100%;
         height: 1rem
     }
      #home  .blockgrayw{
          width: 100%;
          height: 2rem;
      }
     #home .box .boxdata .toptitle{
         width: 100%;
         height: 0.4rem;
        display: flex;
        // background: rgba(84,119,171,.3);
        // background: #eeeeee;
        /* justify-content: space-between; */
     }
      #home .box .boxdata .toptitle .image1{
          width:0.4rem;
          height: 0.4rem;
          margin-left: 0.3rem;
          margin-top: 0.05rem;
      }
      #home .box .boxdata .toptitle .left{
          width:75%;
          margin-left: 3%;
          height: 0.4rem;
          line-height: 0.4rem;
         color: #5477AB;
        //   font-size: 0.28rem;
          
      }
      #home .box .boxdata .toptitle .left span{
        //   font-weight: 600;
           font-size: 0.28rem;
      }
      #home .box .boxdata .toptitle .right span{
        //   font-weight: 600;
           font-size: 0.28rem;
      }
    #home .box .boxdata .toptitle .right{
         height: 0.4rem;
          line-height: 0.4rem;
          width:21%;
        //   margin: 0 5% 0 0;
         color: #5477AB;
          text-align: left;
        //    font-size: 0.28rem;
           font-weight:600;
    }
      #home .box .boxdata .list{
          width: 100%;
          display: flex;
           border-bottom: 0.02rem solid #eeeeee;
      }
      #home .box .boxdata .list li{
          width: 25%;
          text-align: center;
          background: white;
          height: 0.9rem;
          line-height: 0.9rem;
          color: gray;
          font-size: 0.28rem;
        //   border-bottom: 0.02rem solid gray;
      }
      #home .box .boxdata .list li:last-child{
          padding-left: 3%;
        //   width: 20%;
          text-align: left;
      }
     #home .center{
         width:100%;
         height: auto;
         display: flex;
     }
     #home .center li{
         width:25%;
         height:1rem;
         text-align: center;
         line-height: 25%;
     }
     #home .footer{
         width: 100%;
         height: 1rem;
         position: fixed;
         left: 0;
         bottom:0;
         display: flex;
         box-shadow: 0.1rem 0.1rem 0.1rem 0.1rem gray;
     }
     #home .footer button{
        
         border:none;
         border-right: 0.02rem solid #eeeeee;
         width: 50%;
         height: 1rem;
         line-height: 1rem;
         text-align: center;
         font-size: 0.28rem;
         color: #5477AB;
         display: flex;
         /* flex-direction: column; */
     }
      #home .footer .normalbtn{
           background: white;
      }
    #home .footer .clickbtn{
         background: lightgray;
        // color: white;
       
    }
</style>

